% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/treatment_entry.R
\name{Infusion}
\alias{Infusion}
\title{Create one or several infusion(s).}
\usage{
Infusion(
  time,
  amount,
  compartment = NA,
  f = NULL,
  lag = NULL,
  duration = NULL,
  rate = NULL,
  ii = NULL,
  addl = NULL
)
}
\arguments{
\item{time}{treatment time(s), numeric value or vector. First treatment time if used together with ii and addl.}

\item{amount}{total amount to infuse, numeric}

\item{compartment}{compartment index, integer}

\item{f}{fraction of infusion amount, distribution}

\item{lag}{infusion lag time, distribution}

\item{duration}{infusion duration, distribution}

\item{rate}{infusion rate, distribution}

\item{ii}{interdose interval, requires argument 'time' to be a single numeric value}

\item{addl}{number of additional doses, requires argument 'time' to be a single integer value}
}
\value{
a single infusion or a list of infusions.
}
\description{
Create one or several infusion(s).
}
